/*******************************************************************
 * This is a demonstration a template to overload an operator.
 *******************************************************************/

#include<iostream>
#include<string>
#include<vector>
#include<string>
using std::vector;
using std::string;
using std::endl;
using std::cout;
using std::cin;
using std::ostream;

template <class T>
ostream & operator<<(ostream & out, const vector<T> & s);

/* The main function gets a vector of floats and a vector of strings.
 * It uses the same function template, <<, to display both types 
 * of vector.
 */
int main()
{
	float x;
	string word;
	vector<float> nums;
	vector<string> words;
	cout<<"Please enter some floating point values. "<<
		"Enter 's' to stop. ";
	while(cin>>x)
		nums.push_back(x);
	cin.clear();
	cin>>word;//Get the stop word to discard.
	cout<<"\nPlease enter some words. <Enter> <CTRL>-D. to stop: ";
	while(cin>>word)
		words.push_back(word);
	cout<<endl<<"You entered the following numbers:\n";
	cout<<nums;
	cout<<endl<<endl<<"You entered the following words:\n";
	cout<<words;
	return 0;
}


template <class T>
ostream & operator<<(ostream & out, const vector<T> & s)
{
		for(typename vector<T>::const_iterator it=s.begin(); it<s.end(); it++)
		out<<*it<<" ";
		return out;
}
